SystemOrganization addCategory: #Country!

Object subclass: #Country
	instanceVariableNames: 'countryName countryCode currency locale'
	classVariableNames: 'CountryList'
	poolDictionaries: ''
	category: 'Country'!

!Country commentStamp: 'PaulDeBruicker 2/8/2013 11:00' prior: 0!
iso 3166 country codes and names from here:

http://www.iso.org/iso/country_codes/country_codes!

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 12:16'!
addCurrencies
	(Smalltalk at: #Currency) notNil
		ifTrue: [ CountryList do: [ :eachCountry | eachCountry currency: (Currency getFromCountryName: eachCountry countryName) ] ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 11:24'!
countryList
	^ CountryList! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 12:44'!
findByName: aName
	^ self countryList detect: [ :each | each countryName = aName ] ifNone: [ nil ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 13:08'!
findByTwoLetterCode: aTwoLetterCode
	^ self countryList detect: [ :each | each countryCode = aTwoLetterCode ] ifNone: [ self usa ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:36'!
getXMLISOData
	^ ZnEasy get: self githubISOXMLURL ! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:35'!
githubISOXMLURL
	^ 'https://raw.github.com/lukes/ISO-3166-Countries-with-Regional-Codes/master/all/all.xml'! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 12:16'!
initialize
	"
self initialize
"

	self populateCountryList! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:37'!
isoXmlUrl

"ISO has started charging 300CHF/year for this data as of Jan 31 2014"
	^ 'http://www.iso.org/iso/home/standards/country_codes/country_names_and_code_elements_xml.htm'! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:49'!
populateCountryList
	| countryXml |
	countryXml := XMLDOMParser parse: self getXMLISOData contents.
	CountryList := SortedCollection new.
	countryXml firstNode nodes
		do: [ :each | 
			| newCountry |
			newCountry := self new.
			newCountry countryName: (each attributeAt: 'name').
			newCountry countryCode:  (each attributeAt: 'alpha-2').
			CountryList add: newCountry ].
	self addCurrencies! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 13:08'!
usa
	^ self findByTwoLetterCode: 'US'! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/26/2013 12:08'!
<= aCountry
	^ self countryName caseInsensitiveLessOrEqual: aCountry countryName! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryCode
	^ countryCode! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryCode: anObject
	countryCode := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryName
	^ countryName! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryName: anObject
	countryName := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
currency
	^ currency! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
currency: anObject
	currency := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
locale
	^ locale! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
locale: anObject
	locale := anObject! !

!Country methodsFor: 'printing' stamp: 'PaulDeBruicker 2/8/2013 12:18'!
printOn: aStream
	aStream nextPutAll: self countryName! !

!Country methodsFor: 'printing' stamp: 'PaulDeBruicker 2/26/2013 11:43'!
renderOn: html
	html render: self countryName! !
Country initialize!
